config/routes.rb
Rails.application.routes.draw do
  resources :students do 
    get "/check" => "students#check"
  end

  resources :teachers do 
    get "/change_password", to: "teachers#change_password"
  end

  resources :cells do 
    get "/students_personal_details" => 'cells#students_personal_details'
    get "/summary" => 'cells#summary'
  end
  
  resources :instructions
  resources :attendances
  
  resources :users
  resources :sessions, only: [:new, :create, :destroy]
  
  root 'cells#index'
  get '/' => 'cells#index'
  get '/login', to: 'sessions#new', as: 'login'
  get '/logout', to: 'sessions#destroy', as: 'logout'
  get '/search', to: 'application#searchByName'
  get "/admin", to: "application#admin"
  get "/cells_all", to: "cells#all"

end

app/models/teacher.rb
class Teacher < ActiveRecord::Base
    # has_secure_password
    has_many :instructions
    has_many :cells, through: :instructions
    
    validates_presence_of :full_name, :date_birth
    validates_presence_of :street_name, if: :street_number? or :ward? or :district?
    validates :phone, format: { with: /\A\d+\z/, message: "only allows numbers" }, allow_blank: true
    # email = right format, allow nil
    
    def name 
       if self.christian_name
          self.christian_name + " " + self.full_name 
       else
           self.full_name
       end
    end
    
    def address
        self.street_number + " " + self.street_name + ", " + self.ward + ", " + self.district if self.street_name?
    end
end

app/controllers/teachers_controller.rb
class TeachersController < ApplicationController
  before_action :set_teacher, only: [:show, :edit, :update, :destroy]
  before_action :auth 
  before_action :isAdmin, only: [:new, :create, :edit, :update, :destroy, :check]

  # GET /teachers
  # GET /teachers.json
  def index
    @instructions = Instruction.joins(:cell).where("cells.year = ?", @current_year).sort_by {|ins| ins.cell.sort_param}
    
    respond_to do |format|
      format.html
      format.pdf do
        pdf = TeachersPdf.new(@instructions, @current_year)
        send_data pdf.render, filename: "Danh Sách GLV Năm Học #{@current_year_long}.pdf", type: "application/pdf", disposition: "inline"
      end
    end
  end

  # GET /teachers/1
  # GET /teachers/1.json
  def show
    @cells = @teacher.cells
    
    @years = Cell.all.map{|c| c.year}.uniq.sort{|x,y| -(x <=> y)}
    @opts = Array.new
    Cell.all.sort_by{|c| c.sort_param}.each do |cell|
      if cell.year == @years[0]
        @opts.push([cell.name, cell.id])
      end
    end
  end

  # GET /teachers/new
  def new
    @teacher = Teacher.new
  end

  # GET /teachers/1/edit
  def edit
  end

  # POST /teachers
  # POST /teachers.json
  def create
    @teacher = Teacher.new(teacher_params)

    respond_to do |format|
      if @teacher.save
        flash[:success] = 'Teacher was successfully created.'
        format.html { redirect_to @teacher }
        format.json { render :show, status: :created, location: @teacher }
      else
        format.html { render :new }
        format.json { render json: @teacher.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /teachers/1
  # PATCH/PUT /teachers/1.json
  def update
    respond_to do |format|
      if @teacher.update(teacher_params)
        flash[:success] = 'Teacher was successfully updated.'
        format.html { redirect_to @teacher }
        format.json { render :show, status: :ok, location: @teacher }
      else
        format.html { render :edit }
        format.json { render json: @teacher.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /teachers/1
  # DELETE /teachers/1.json
  def destroy
    @teacher.instructions.each do |ins|
      ins.destroy
    end

    @teacher.destroy
    respond_to do |format|
      flash[:success] = 'Teacher was successfully destroyed.'
      format.html { redirect_to teachers_url }
      format.json { head :no_content }
    end
  end

  def change_password
    get_teacher
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_teacher
      @teacher = Teacher.find(params[:id])
    end

    def get_teacher
      @teacher = Teacher.find(params[:teacher_id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def teacher_params
      params.require(:teacher).permit(
        :christian_name, 
        :full_name, 
        :named_date, 
        :date_birth, 
        :occupation, 
        :phone, 
        :email, 
        :street_number, 
        :street_name, 
        :ward, 
        :district,
        :password, 
        :password_confirmation,
        :is_admin
      )
    end
end

app/helpers/teachers_helper.rb
module TeachersHelper
end

app/views/teachers/_form.html.erb
<%= form_for(@teacher) do |f| %>
  <% if @teacher.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@teacher.errors.count, "error") %> prohibited this teacher from being saved:</h2>

      <ul>
      <% @teacher.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <fieldset>
    <div class="block">
      <div class="label">Tên Thánh:</div>
      <%= f.text_field :christian_name %>
    </div>
  
    <div class="block">
      <div class="label">Họ và Tên:</div>
      <%= f.text_field :full_name %>
    </div>

    <div class="block">
      <div class="label">Ngày Sinh:</div>
      <%= f.date_select :date_birth, {
        :start_year => 1900,
        :end_year => Date.today.year + 5,
        :include_blank => true, 
        :default => nil, 
        :use_two_digit_numbers => true, 
        :order => [:day, :month, :year], 
        :with_css_classes => true, 
        :prompt => {:day => "Ngày", :month => "Tháng", :year => "Năm"}
      }%>
    </div>
    
    <div class="block">
      <div class="label">Bổn Mạng:</div>
      <%= f.text_field :named_date %>
    </div>
    
    <div class="block">
      <div class="label">Nghề Nghiệp:</div>
      <%= f.text_field :occupation %>
    </div>
    
    <div class="block">
      <div class="label">Số Điện Thoại:</div>
      <%= f.text_field :phone %>
    </div>
    
    <div class="block">
      <div class="label">Email:</div>
      <%= f.text_field :email %>
    </div>
    
    <div class="block"></div>
    
    <div class="block">
      <div class="label">Số Nhà:</div>
      <%= f.text_field :street_number %>
    </div>
    
    <div class="block">
      <div class="label">Đường:</div>
      <%= f.text_field :street_name %>
    </div>
    
    <div class="block">
      <div class="label">Phường/Xã:</div>
      <%= f.text_field :ward %>
    </div>
    
    <div class="block">
      <div class="label">Quận/Huyện:</div>
      <%= f.text_field :district %>
    </div>
  </fieldset>
  <div class="actions">
    <%= f.submit "Cập Nhật", :class => "button"%>
  </div>
<% end %>

app/views/teachers/_info_table.html.erb
<table>
  <thead>
    <tr>
      <th style='width:  30px'>STT</th>
      <th style='width:  80px'>Lớp</th>
      <th style='width:  80px'>Phụ Trách</th>
      <th style='width: 280px'>Tên Thánh - Họ và Tên</th>
      <th style='width:  80px'>Ngày Sinh</th>
      <th style='width: 130px'>Bổn Mạng</th>
      <th style='width: 220px'>Địa Chỉ</th>
      <th style='width: 220px'>Email</th>
      <th style='width:  90px'>Điện Thoại</th>
    </tr>
  </thead>

  <tbody>
    <% @instructions.each_with_index do |instruction, index| %>
    <% cell = instruction.cell %>
    <% teacher = instruction.teacher %>

      <tr class="table-row">
        <td style='width:  30px'><%= index+1 %></td> 
        <td style='width:  80px'><%= link_to cell.name, cell %></td> 
        <td style='width:  80px'><%= link_to instruction.position, edit_instruction_path(instruction) %></td>
        <td style='width: 280px'><%= link_to teacher.name, teacher %></td>
        <td style='width: 100px'><%= teacher.date_birth.strftime("%d-%m-%Y") %></td>
        <td style='width: 110px'><%= teacher.named_date %></td>
        <td style='width: 220px'><%= teacher.address %></td>
        <td style='width: 220px'><%= teacher.email %></td>
        <td style='width:  90px'><%= teacher.phone %></td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/teachers/change_password.html.erb
<%= form_for(@teacher) do |f| %>
    <% if @teacher.errors.any? %>
      <div id="error_explanation">
        <h2><%= pluralize(@teacher.errors.count, "error") %> prohibited this teacher from being saved:</h2>
  
        <ul>
        <% @teacher.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
        </ul>
      </div>
    <% end %>
  
    <div class="field">
      <%= f.label :password %>
      <%= f.password_field :password %>
    </div>
  
    <div class="field">
      <%= f.label :password_confirmation %>
      <%= f.password_field :password_confirmation %>
    </div>

    <div class="field">
    <%= f.label :is_admin %>
    <%= f.check_box :is_admin %>
  </div>
  
    <div class="actions">
      <%= f.submit %>
    </div>
  <% end %>
  

app/views/teachers/edit.html.erb
<h1>Cập Nhật Thông Tin Giáo Lý Viên</h1>

<%= render 'form' %>
<%= link_to 'Quay Lại', :back, :class => "button" %>
<%= link_to 'Xóa', @teacher, method: :delete, data: { confirm: 'Xóa hết thông tin và Hành Trình Thiêng Liêng của giáo lý viên? Nên cập nhật thông tin thay vì xóa. Are you sure?' }, :class => "button-caution" %>

app/views/teachers/index.html.erb
<h1>Nhân sự phụ trách Giáo dục Đức tin Năm Học <%= @current_year_long %></h1>
<h4>Số Lượng : <%= @instructions.count %></h4>

<%= render 'info_table' %>

<div class="divider"></div>
<%= link_to "In Danh Sách GLV", teachers_path(format: "pdf"), :class => "button" %>

app/views/teachers/new.html.erb
<h1>New Teacher</h1>

<%= render 'form' %>

<%= link_to 'Quay Lại', :back, :class => "button" %>

app/views/teachers/show.html.erb
<h1>Thông Tin Giáo Lý Viên</h1>
<p style="margin: 10px"></p>

<fieldset>
  <div class="block">
    <div class="label">Tên Thánh - Họ và Tên:</div>
    <strong><%= @teacher.name %></strong>
  </div>
  
  <div class="block">
    <div class="label">Ngày Sinh:</div>
    <strong><%= @teacher.date_birth %></strong>
  </div>
  
  <div class="block">
    <div class="label">Nghề Nghiệp:</div>
    <strong><%= @teacher.occupation %></strong>
  </div>
  
  <div class="block">
    <div class="label">Bổn Mạng:</div>
    <strong><%= @teacher.named_date %></strong>
  </div>
  
  <div class="block">
    <div class="label">Số Điện Thoại:</div>
    <strong><%= @teacher.phone %></strong>
  </div>
  
  <div class="block">
    <div class="label">Email:</div>
    <strong><%= @teacher.email %></strong>
  </div>
  
  <div>
    <div class="label">Địa Chỉ:</div>
    <strong><%= @teacher.address %></strong>
  </div>
  
</fieldset>

<%= link_to 'Chỉnh Sửa', edit_teacher_path(@teacher), :class => "button" %>


<div class="divider"></div>
<h1>Hành Trình Thiêng Liêng</h1>

<table>
  <thead>
    <tr>
      <th style='width: 100px'>Năm Học</th>
      <th style='width: 100px'>Tên Lớp</th>
      <th style='width: 100px'>Phụ Trách</th>
      <th style='width: 200px'>Vị Trí</th>
    </tr>
  </thead>

  <tbody>
    <% @cells.each do |cell| %>
    <% instruction = @teacher.instructions.select { |ins| ins.cell_id == cell.id }.first %>
    <% default_location = "Vô Gia Cư"; default_location = cell.location if cell.location? %>
    <% default_position = "_"; default_position = instruction.position if instruction.position? %>
      <tr class="table-row">
        <td style='width: 200px'><%= cell.long_year %></td>
        <td style='width: 200px'><%= link_to cell.name, cell %></td>
        <td style='width: 200px'><%= link_to default_position, edit_instruction_path(instruction.id) %></td>
        <td style='width: 200px'><%= default_location %></td>
      </tr>
    <% end %>
    
    
    
    
    <tr class="table-row">   
      <td id="form" style="font-size: 14px; display: none" colspan="4">
        <% @instruction = Instruction.new %>
        <%= form_for(@instruction) do |f| %>
          <% if @instruction.errors.any? %>
            <div id="error_explanation">
              <h2><%= pluralize(@instruction.errors.count, "error") %> prohibited this instruction from being saved:</h2>
        
              <ul>
              <% @instruction.errors.full_messages.each do |message| %>
                <li><%= message %></li>
              <% end %>
              </ul>
            </div>
          <% end %>
          <%= f.hidden_field :teacher_id, :value => @teacher.id %>
          <select id="year_combobox" onchange="changeCell()">
            <% selected_year = @years[0] %>
            <% @years.each do |year| %>
              <option value="<%=year%>"><%= year.to_s + " - " + (year.to_i+1).to_s %></option>
            <% end %>
          </select>
          <%= f.select :cell_id, options_for_select(@opts), :id => 'cell_id' %>
          <%= f.select :position, options_for_select(["Tu Sĩ", "GLV", "Tiền GLV", "Phụ Tá", "Kiến Tập"]), :style => "width: 98px"%>
          <%= f.submit "Thêm Lớp Mới" %>
        <% end %>
      </td>
    </tr>
  </tbody>
</table>

<center><button id="btn" onClick="showForm()" class="button" style="width:500px">Thêm Lớp Mới</button></center>

<script>
  function showForm() {
    document.getElementById("btn").style.display = "none";
    document.getElementById("form").style.display = "table-cell";
  }
  
  function changeCell() {
    var e = document.getElementById("year_combobox");
    var selected = e.options[e.selectedIndex].value;

    
    //Create array of options to be added
    var hash = {};
    var keys = [];
    
    <% Cell.all.sort_by{|c| c.sort_param}.each do |cell| %>
    if(selected == "<%= cell.year %>") {
      hash[<%= cell.id %>] = "<%= cell.name %>";
      keys.push(<%= cell.id %>);
    }
    <% end %>
    
    
    var list = document.getElementById("instruction_cell_id");
    list.options.length = 0;
    
    
    //Create and append the options
    for (var i = 0; i < keys.length; i++) {
        var option = document.createElement("option");
        option.value = keys[i];
        option.text = hash[keys[i]];
        list.appendChild(option); 
    }
    
  }
</script>